package it.micegroup.gestioneferie.configurazionepf.service;

import java.util.Map;
import java.util.List;
import java.util.Locale;
import java.util.HashMap;
import java.util.Optional;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;

import org.springframework.context.i18n.LocaleContextHolder;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import it.micegroup.voila2runtime.filter.LongFilter;

import it.micegroup.gestioneferie.configurazionepf.entity.DregolePianiFerieH;

import it.micegroup.gestioneferie.configurazionepf.entity.DregolePianiFeriePk;

import it.micegroup.gestioneferie.configurazionepf.entity.DregolePianiFerieH_;
import it.micegroup.gestioneferie.configurazionepf.criteria.DregolePianiFerieHCriteria;
import it.micegroup.gestioneferie.configurazionepf.repository.DregolePianiFerieHRepository;
import it.micegroup.voila2runtime.specification.FilterService;

import it.micegroup.gestioneferie.configurazionepf.entity.DregolePianiFerieH_;
import it.micegroup.gestioneferie.configurazionepf.entity.DregolePianiFeriePk_;
import lombok.RequiredArgsConstructor;
import it.micegroup.gestioneferie.libs.service.BaseServiceImpl;

import it.micegroup.voila2runtime.exception.BusinessException;
import net.sf.jasperreports.engine.JRException;

@RequiredArgsConstructor
@Service
@Transactional
public class DregolePianiFerieHServiceImpl extends BaseServiceImpl implements DregolePianiFerieHService {

	private final DregolePianiFerieHRepository dregolePianiFerieHRepository;
	private final FilterService<DregolePianiFerieH> filterService;

	// CHILD SERVICES

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DregolePianiFerieHServiceImpl.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findAll(org. springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DregolePianiFerieH> findAll(Pageable pageable) {
		return dregolePianiFerieHRepository.findAll(pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findAll()
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DregolePianiFerieH> findAll() {
		return dregolePianiFerieHRepository.findAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findByCriteria(java. lang.Object, org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DregolePianiFerieH> findByCriteria(DregolePianiFerieHCriteria criteria, Pageable pageable) {
		final Specification<DregolePianiFerieH> specification = createSpecification(criteria);
		return dregolePianiFerieHRepository.findAll(specification, pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findByCriteria(java. lang.Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DregolePianiFerieH> findByCriteria(DregolePianiFerieHCriteria criteria) {
		final Specification<DregolePianiFerieH> specification = createSpecification(criteria);
		return dregolePianiFerieHRepository.findAll(specification);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findById(java.lang. Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DregolePianiFerieH> findById(Long id) {
		return dregolePianiFerieHRepository.findBySequIdRegolePianiFerieH(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * exists(java.lang. Object)
	 */
	@Override
	public boolean exists(Long id) {
		return dregolePianiFerieHRepository.existsById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * insert(java. lang.Object)
	 */
	@Override
	public DregolePianiFerieH insert(@Valid DregolePianiFerieH entity) {
		return dregolePianiFerieHRepository.save(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * update(java. lang.Object)
	 */
	@Override
	public DregolePianiFerieH update(@Valid DregolePianiFerieH entity) {
		return dregolePianiFerieHRepository.save(entity);
	}

	@Override
	public void delete(DregolePianiFerieH entity) {
		dregolePianiFerieHRepository.delete(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * deleteById(java.lang. Object)
	 */
	@Override
	public void deleteById(Long id) {
		dregolePianiFerieHRepository.deleteById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * deleteByIdIn(java.lang. Object)
	 */
	@Override
	public void deleteByIdIn(Collection<Long> ids) {
		dregolePianiFerieHRepository.deleteByIdIn(ids);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.configurazionepf.service.GenericEntityService#
	 * findByObjectKey(java.lang.String)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DregolePianiFerieH> findByObjectKey(String id) {
		DregolePianiFerieH dregolePianiFerieH = new DregolePianiFerieH(id);

		return findById(dregolePianiFerieH.getSequIdRegolePianiFerieH());
	}

	@Override
	public Page<DregolePianiFerieH> findByTheDregolePianiFeriePk(DregolePianiFeriePk parentEntity, Pageable pageable) {
		return dregolePianiFerieHRepository.findByTheDregolePianiFeriePk(parentEntity, pageable);
	}

	/**
	 * Convert DregolePianiFerieHCriteria to a {@link Specification}
	 * 
	 * @param criteria
	 * @return
	 */
	private Specification<DregolePianiFerieH> createSpecification(DregolePianiFerieHCriteria criteria) {
		Specification<DregolePianiFerieH> specification = Specification.where(null);

		if (criteria != null) {
			// Attribute filters
			if (criteria.getSequIdRegolePianiFerieH() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getSequIdRegolePianiFerieH(), DregolePianiFerieH_.sequIdRegolePianiFerieH));
			}
			if (criteria.getNumMinGgDaPianificare() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getNumMinGgDaPianificare(), DregolePianiFerieH_.numMinGgDaPianificare));
			}
			if (criteria.getNumMaxGgDaPianificare() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getNumMaxGgDaPianificare(), DregolePianiFerieH_.numMaxGgDaPianificare));
			}
			if (criteria.getNumePercMinGiorniPresenza() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getNumePercMinGiorniPresenza(), DregolePianiFerieH_.numePercMinGiorniPresenza));
			}
			if (criteria.getFlagValidoUoSubordinate() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getFlagValidoUoSubordinate(), DregolePianiFerieH_.flagValidoUoSubordinate));
			}
			if (criteria.getFkAmministrazione() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkAmministrazione(), DregolePianiFerieH_.fkAmministrazione));
			}
			if (criteria.getFkRegolaPianoFeriePk() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkRegolaPianoFeriePk(), DregolePianiFerieH_.fkRegolaPianoFeriePk));
			}
			if (criteria.getFkTipoOrganigramma() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkTipoOrganigramma(), DregolePianiFerieH_.fkTipoOrganigramma));
			}
			if (criteria.getFkUnitaFunzionale() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkUnitaFunzionale(), DregolePianiFerieH_.fkUnitaFunzionale));
			}
			if (criteria.getFkUnitaOrganizzativaPk() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkUnitaOrganizzativaPk(), DregolePianiFerieH_.fkUnitaOrganizzativaPk));
			}
			if (criteria.getFlagEliminato() != null) {
				specification = specification.and(filterService.generateStringSpecification(criteria.getFlagEliminato(),
						DregolePianiFerieH_.flagEliminato));
			}
			if (criteria.getUtenteUltimaModifica() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getUtenteUltimaModifica(), DregolePianiFerieH_.utenteUltimaModifica));
			}
			if (criteria.getDataUltimaModifica() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataUltimaModifica(), DregolePianiFerieH_.dataUltimaModifica));
			}
			if (criteria.getDataInizioValidita() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataInizioValidita(), DregolePianiFerieH_.dataInizioValidita));
			}
			if (criteria.getDataFineValidita() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataFineValidita(), DregolePianiFerieH_.dataFineValidita));
			}

			if (criteria.getTheDregolePianiFeriePkObjectKey() != null) {
				DregolePianiFeriePk dregolePianiFeriePk = new DregolePianiFeriePk(
						criteria.getTheDregolePianiFeriePkObjectKey());

				specification = specification.and(
						filterService.generateEqualsSpecification(dregolePianiFeriePk.getSequIdRegolePianiFeriePk(),
								r -> r.get(DregolePianiFerieH_.theDregolePianiFeriePk)
										.get(DregolePianiFeriePk_.sequIdRegolePianiFeriePk)));
			}

		}
		return specification;
	}

	@Override
	@Transactional()
	public DregolePianiFerieH bulkUpdate(DregolePianiFerieH dregolePianiFerieH) {

		DregolePianiFerieH update = this.update(dregolePianiFerieH);

		return update;
	}
}
